%define section   free

Name:           derby
Version:        10.0.2.1
Release:        2jpp
Epoch:          0
Summary:        Derby DB (ex Cloudscape)

Group:          Database
License:        Apache License Version 2.0
URL:            http://incubator.apache.org/derby/index.html
Source0:        incubating-derby-10.0.2.1-src.tar.gz
Source1:        derby-10.0.2.1-test.script
Patch0:         derby-10.0.2.1-build_xml.patch
Patch1:         derby-10.0.2.1-JDBC30only-BrokeredConnection.patch
Patch2:         derby-10.0.2.1-JDBC30only-BrokeredCallableStatement.patch
Patch3:         derby-10.0.2.1-JDBC30only-BrokeredPreparedStatement.patch
Patch4:         derby-10.0.2.1-JDBC30only-BrokeredCallableStatement30.patch
Patch5:         derby-10.0.2.1-JDBC30only-BrokeredConnection30.patch
Patch6:         derby-10.0.2.1-JDBC30only-EmbedConnection20.patch
Patch7:         derby-10.0.2.1-JDBC30only-EmbedPreparedStatement20.patch
Patch8:         derby-10.0.2.1-JDBC30only-EmbedCallableStatement20.patch
Patch9:         derby-10.0.2.1-JDBC30only-ExternalTable.patch
Patch10:        derby-10.0.2.1-langUnitTests.patch


BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Distribution:   JPackage
Vendor:         JPackage Project

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  java-devel >= 0:1.4.2
BuildRequires:  javacc
BuildRequires:  jta
BuildRequires:  oro
BuildRequires:  servletapi5
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:  java >= 0:1.4.2
Requires:  jta
Requires:  oro
Requires:  servletapi5
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  xml-commons-apis

%description
The Derby project develops open source database technology 
that is: Pure Java, Easy to use, Small footprint, Standards 
based, Secure.
The core of the technology, Derby.s database engine is a 
full functioned relational embedded database engine. JDBC 
and SQL are the programming APIs. 
The Derby network server increases the reach of the Derby 
database engine by providing traditional client server 
functionality. The network server allows clients to connect 
over TCP/IP using the standard DRDA protocol. The network 
server allows the Derby engine to support networked JDBC, 
ODBC/CLI, Perl and PHP. 
Database Utilities:
ij -- a tool that allows SQL scripts to be executed against 
      any JDBC database. 
dblook -- Schema extraction tool for a Derby database. 
sysinfo -- Utility to display version numbers and class path. 


%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}

%package        manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description    manual
Documents for %{name}

%package        demo
Summary:        Examples for %{name}
Group:          Development/Documentation

%description    demo
Examples for %{name}

%prep
%setup -q -n incubating-%{name}-%{version}-src


%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav

%build
# set both jres to 1.4.2 !!
cat > build.properties <<EOF
j14lib=/usr/lib/jvm/java-1.4.2/jre/lib
j13lib=/usr/lib/jvm/java-1.4.2/jre/lib
#build.compiler=jikes
#proceed=true
#sane=false
EOF
pushd tools/java
ln -sf $(build-classpath javacc) .
ln -sf $(build-classpath jta) .
ln -sf $(build-classpath jce) .
ln -sf $(build-classpath servletapi5) .
#ln -sf $(build-classpath jndi) .
#ln -sf $(build-classpath jndi-ldap) .
ln -sf $(build-classpath oro) .
ln -sf $(build-classpath xalan-j2) .
ln -sf $(build-classpath xerces-j2) .
ln -sf $(build-classpath xml-commons-apis) .
popd

export OPT_JAR_LIST="ant/ant-nodeps"
ant buildsource testing buildjarsclean javadoc

mkdir testdir
cp %{SOURCE1} testdir/testderby.sh
pushd testdir
chmod +x testderby.sh
./testderby.sh
for f in $(find . -name "*.fail"); do
	echo FAILED $f
	cat $f
done
popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -pm 644 jars/sane/derby.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derby-%{version}.jar
install -pm 644 jars/sane/derbyLocale_de_DE.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_de_DE-%{version}.jar
install -pm 644 jars/sane/derbyLocale_es.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_es-%{version}.jar
install -pm 644 jars/sane/derbyLocale_fr.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_fr-%{version}.jar
install -pm 644 jars/sane/derbyLocale_it.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_it-%{version}.jar
install -pm 644 jars/sane/derbyLocale_ja_JP.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_ja_JP-%{version}.jar
install -pm 644 jars/sane/derbyLocale_ko_KR.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_ko_KR-%{version}.jar
install -pm 644 jars/sane/derbyLocale_pt_BR.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_pt_BR-%{version}.jar
install -pm 644 jars/sane/derbyLocale_zh_CN.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_zh_CN-%{version}.jar
install -pm 644 jars/sane/derbyLocale_zh_TW.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyLocale_zh_TW-%{version}.jar
install -pm 644 jars/sane/derbynet.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbynet-%{version}.jar
install -pm 644 jars/sane/derbyTesting.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbyTesting-%{version}.jar
install -pm 644 jars/sane/derbytools.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}/derbytools-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 jars/sane/derby.war \
	$RPM_BUILD_ROOT%{_datadir}/%{name}/derby-%{version}.war
install -pm 644 CHANGES $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 COPYRIGHT $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 LICENSE $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 NOTICE $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 README $RPM_BUILD_ROOT%{_datadir}/%{name}
install -pm 644 STATUS $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/publishedapi $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/engine $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
install -dm 755 $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr javadoc/language $RPM_BUILD_ROOT%{_docdir}/%{name}
cp -pr javadoc/tools $RPM_BUILD_ROOT%{_docdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}
%{_datadir}/%{name}

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root,-)
%doc %{_docdir}/%{name}

%changelog
* Fri Mar 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:10.0.2.1-2jpp
- Scrap jndi references
- Add OPT_JAR_LIST with ant/ant-nodeps

* Tue Feb 08 2005 Ralph Apel <r.apel at r-apel.de> - 0:10.0.2.1-1jpp
- First JPackage release
- Naively patched to NOT require Java-1.3 nor its extensions
- Tests pass successfully
